/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CRIA_LISTA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/*    26/08/2004 - Joo Fernando dos Reis Corra                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE CRIA_LISTA
(
   P_CDFILIAL     IN ITMPREVLIST.CDFILIAL%TYPE,
   P_NRSEQPRELIST IN ITMPREVLIST.NRSEQPRELIST%TYPE,
   P_ROWSAFFECT  OUT INT
)
IS
   V_CONT_COMMIT     INT := 0;
   V_QTDE_COMMIT     INT := 1000;
   V_COUNT           INT := 0;
   V_IDCOINVALIDLIST PREVLISTA.IDCOINVALIDLIST%TYPE;
   V_IDITVALDIFLISTA ITEMCOLE.IDITVALDIFLISTA%TYPE;
   V_DTINIVALLIST    DATE;
   V_DTFINVALLIST    DATE;
BEGIN
   SELECT
      MAX(DTINIVALLIST),
      MAX(DTFINVALLIST),
      MAX(IDCOINVALIDLIST)
   INTO
       V_DTINIVALLIST,
       V_DTFINVALLIST,
       V_IDCOINVALIDLIST
   FROM PREVLISTA
   WHERE CDFILIAL = P_CDFILIAL
     AND NRSEQPRELIST = P_NRSEQPRELIST;

   FOR C_ITMPREVLIST IN
      (SELECT
          ITMPREVLIST.CDFILIAL,
          ITMPREVLIST.NRCOLEPRECO,
          ITMPREVLIST.CDFORNECED,
          ITMPREVLIST.CDREGIAO,
          ITMPREVLIST.CDPRODUTO,
          ITMPREVLIST.CDMARCA,
          ITMPREVLIST.ROWID
       FROM
          ITMPREVLIST
       WHERE ITMPREVLIST.CDFILIAL = P_CDFILIAL
         AND ITMPREVLIST.NRSEQPRELIST = P_NRSEQPRELIST
         AND ITMPREVLIST.IDITMLISTJAMONT = 'N'
         AND ROWNUM <= V_QTDE_COMMIT
       )
   LOOP
      V_COUNT := 0;
      V_IDITVALDIFLISTA := 'N';
      IF V_IDCOINVALIDLIST = 'N' THEN
         SELECT COUNT(1)
         INTO V_COUNT
         FROM ITEMCOLE
         WHERE ITEMCOLE.CDFILIAL     = C_ITMPREVLIST.CDFILIAL
           AND ITEMCOLE.NRCOLEPRECO  = C_ITMPREVLIST.NRCOLEPRECO
           AND ITEMCOLE.CDFORNECED   = C_ITMPREVLIST.CDFORNECED
           AND ITEMCOLE.CDREGIAO     = C_ITMPREVLIST.CDREGIAO
           AND ITEMCOLE.CDPRODUTO    = C_ITMPREVLIST.CDPRODUTO
           AND ITEMCOLE.CDMARCA      = C_ITMPREVLIST.CDMARCA
           AND (ITEMCOLE.DTINIVALITM <> V_DTINIVALLIST OR ITEMCOLE.DTFINVALITM <> V_DTFINVALLIST);
         IF V_COUNT > 0 THEN
            V_IDITVALDIFLISTA := 'S';
         END IF;
      END IF;

      UPDATE
         ITEMCOLE
      SET
         IDITMLISPREC = 'S',
         IDPRECALT    = 'N',
         IDITVALDIFLISTA = V_IDITVALDIFLISTA,
         NRSEQPRELIST = P_NRSEQPRELIST
      WHERE ITEMCOLE.CDFILIAL = C_ITMPREVLIST.CDFILIAL
        AND ITEMCOLE.NRCOLEPRECO = C_ITMPREVLIST.NRCOLEPRECO
        AND ITEMCOLE.CDFORNECED  = C_ITMPREVLIST.CDFORNECED
        AND ITEMCOLE.CDREGIAO    = C_ITMPREVLIST.CDREGIAO
        AND ITEMCOLE.CDPRODUTO   = C_ITMPREVLIST.CDPRODUTO
        AND ITEMCOLE.CDMARCA     = C_ITMPREVLIST.CDMARCA;

      UPDATE
         ITMPREVLIST
      SET
         IDITMLISTJAMONT = 'S'
      WHERE
         ITMPREVLIST.ROWID = C_ITMPREVLIST.ROWID;

      V_CONT_COMMIT := V_CONT_COMMIT + 1;
      IF (V_CONT_COMMIT >= V_QTDE_COMMIT) THEN
         EXIT;
      END IF;
   END LOOP;
   P_ROWSAFFECT := V_CONT_COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CRIA_LISTA','5.05.003'); END;
/

